#include <jni.h>
#include <sys/unistd.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <stdlib.h>
#include <sys/uio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include "activePacket.h"
#include "activePacketP.h"
#include "anepP.h"
#include "ActivePacket.h"



activeSocketHandle_t *ash;

JNIEXPORT void JNICALL 
Java_ActivePacket_init_1socket (JNIEnv *env, jobject jobj, jstring mcast_addr, jint port)

{ int S;
  char *service="MulticastS"; 
  char *maddr = (char *)(*env)->GetStringUTFChars(env,mcast_addr,0);   
  ash =  mactiveSocket(S,0,service,maddr,port);
  if (ash!=NULL)
    printf("c'est ok");

}


activeSocketHandle_t * mactiveSocket(void *socket, int type, char *service,char *destIp, int port)
{ 
  int iret;
  char optionsBuffer[IP_OPTIONS_SIZE];
  char *pBuf;
  activeSocketHandle_t *pActSock;
  socklen_t len;
  struct sockaddr_in sckAddr;
  char addrSrcStr[INET_ADDRSTRLEN];
  //char addrDestStr[INET_ADDRSTRLEN];
  //int ival;
  TLV_t TLVs[5];
  
  struct hostent *h;
  struct sockaddr_in servAddr;
  unsigned char ttl = 128;


   /* Create hActiveSocket structure */
  pActSock = (activeSocketHandle_t *)malloc(sizeof(activeSocketHandle_t));

   if ( pActSock == NULL )
    {
      activePacket_M_error(0);
      return(NULL);
    }
  
  //Init memory
  memset(pActSock, 0, sizeof(activeSocketHandle_t));
  
  //Socket descriptor
  pActSock->socketType = type;

  if (pActSock->socketType!=SOCK_DGRAM)
     {activePacket_M_error(pActSock->socketType);
      return(NULL);
     }


  //ANEP header info

  //SrcId: sender's IP (from socket)
  len = sizeof(sckAddr);
  getsockname(*((int *)socket), (struct sockaddr *)&sckAddr, &len);
  
  if ( inet_ntop(AF_INET, &sckAddr.sin_addr, addrSrcStr, INET_ADDRSTRLEN) == NULL )
    {
      activePacket_M_errno(errno);
      return(NULL);
    }
  
  TLVs[0].type = TAMANOIR_SRC_IP_TYPE;
  TLVs[0].len = strlen(addrSrcStr);
  TLVs[0].value = addrSrcStr;


  //DestId: receiver's IP from arguments

  TLVs[1].type = TAMANOIR_DEST_IP_TYPE;
  TLVs[1].len = strlen(destIp);
  TLVs[1].value = destIp;

  //LastTan: null 
  TLVs[2].type = TAMANOIR_LAST_TAN_TYPE;
  TLVs[2].len = 0;
  TLVs[2].value = NULL;

  //proxyTan: receiver's proxy TAN IP null 
  TLVs[3].type = TAMANOIR_PROXY_TAN_TYPE;
  TLVs[3].len = 0;
  TLVs[3].value = NULL;

  //serviceName: name of the service to invoke
  TLVs[4].type = TAMANOIR_SERVICE_NUMBER_TYPE;
  TLVs[4].len = strlen(service);
  TLVs[4].value = service;

  iret = anepCreate(128, 5, TLVs, &pActSock->anepHeaderSize, &pActSock->anepHeader); //###TBCheck: using default flags=128
  
  if ( iret != 0 )
    return(NULL);
    
  /* Set the Router Alert field */
  //Get the previous value
  memset(optionsBuffer, IPOPT_END, IP_OPTIONS_SIZE);
  memset(pActSock->passiveConf.ipOptions, IPOPT_END, IP_OPTIONS_SIZE);
  
  len = IP_OPTIONS_SIZE;
  iret = getsockopt(pActSock->socket.socket, IPPROTO_IP, IP_OPTIONS, (void *)optionsBuffer, &len);
  
  memcpy(pActSock->passiveConf.ipOptions, optionsBuffer, len);
  pActSock->passiveConf.ipOptionsLen = len;
  
  pBuf = optionsBuffer;
  while ( *pBuf != IPOPT_END )
    pBuf++;
  
  if ( pBuf - optionsBuffer > IP_OPTIONS_SIZE - 4 )
    {
      activePacket_M_errno(errno);
      return(NULL);
    }
  
  *pBuf = IPOPT_RA; //Option copy-class-number
  pBuf++;
  *pBuf = 4;        //Option length
  pBuf++;
  *pBuf = 0;        //Option data, cf ip_options.c
  pBuf++;
  *pBuf = 0;        //Option data, cf ip_options.c
  pBuf++;
  
  len = len + 4;
  
  while ( len & 3 )
    len++; //Align on 32bits boundary
  
  if ( len > IP_OPTIONS_SIZE )
    len = IP_OPTIONS_SIZE;
  
  iret = setsockopt(pActSock->socket.socket, IPPROTO_IP, IP_OPTIONS, (void *)optionsBuffer, len);
  //###TBD: check num version du datagramme IP (IPv4 vs IPv6).
  
  if ( iret != 0 )
    {
      activePacket_M_errno(errno);
      return(NULL);
    }
  

  h = gethostbyname (destIp);
  servAddr.sin_family = h->h_addrtype;
  servAddr.sin_port =htons(port);
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0],h->h_length);

  /*Check if the address is multicast*/

  if(!IN_MULTICAST(ntohl(servAddr.sin_addr.s_addr)))
     { 
        activePacket_M_errno(errno);
	return(NULL);
     }

  /*set ttl value*/
  if (setsockopt(pActSock->socket.socket,IPPROTO_IP,IP_MULTICAST_TTL,&ttl,sizeof(ttl))<0)
     {  
        activePacket_M_errno(errno);	
        return(NULL);
      }
      
  /*connect the socket to the multicast address*/
  if (connect(pActSock->socket.socket,(struct sockaddr *)&servAddr, sizeof(servAddr))<0)
    {  
        activePacket_M_errno(errno);	
        return(NULL);
    }
     
  return(pActSock);
     
}
