#include <jni.h>
#include "ActiveReceive.h"

#include <errno.h>
#include <stdlib.h>
#include <sys/uio.h>

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#define datasize 6044
int S;
char *maddr;
struct sockaddr_in servAddr;
struct sockaddr_in  cliAddr;
jbyte buf[datasize];


JNIEXPORT void JNICALL 

Java_ActiveReceive_init_1socket (JNIEnv *env, jobject jobj, jstring mcast_addr, jint port)

{ 
  struct hostent *h;
  
  struct in_addr mcastAddr;
  struct ip_mreq mreq;
  unsigned char ttl = 16;
  int iret,rc;
  socklen_t len;
  char *pBuf;  

  maddr = (char *)(*env)->GetStringUTFChars(env,mcast_addr, 0);
  
  h = gethostbyname (maddr);
  
  if (h==NULL)
    {printf("%s: Unknow host\n",*maddr);
     exit (1);
    }

  memcpy(&mcastAddr,h->h_addr_list[0],h->h_length);

  if(!IN_MULTICAST(ntohl(mcastAddr.s_addr)))
    { printf("%s: is not  multicast\n", maddr);
      exit(1);
    }

  S = socket (AF_INET,SOCK_DGRAM,0);

  if (S<0)
    { printf("cannot open socket\n");
     exit(1);
    }

  servAddr.sin_family=AF_INET;
  servAddr.sin_addr.s_addr=htonl(INADDR_ANY);
  servAddr.sin_port=htons(port);

  if (bind(S,(struct sockaddr *) &servAddr, sizeof(servAddr))<0)
    { printf("cannot bind socket\n");
      exit(1);
    }

  mreq.imr_multiaddr.s_addr=mcastAddr.s_addr;
  mreq.imr_interface.s_addr=htonl(INADDR_ANY);
  
 rc=setsockopt(S,IPPROTO_IP,IP_ADD_MEMBERSHIP,(void *) &mreq,sizeof(mreq));

  if (rc<0) {
  printf ("cannot join multicast group\n");
  exit(1);
  }
  

}


JNIEXPORT jbyteArray JNICALL 
Java_ActiveReceive_read (JNIEnv *env, jobject jobj)
{  
  int i=0; 
  
  int cliLen = sizeof(cliAddr);

  ssize_t  n = recvfrom(S,buf,datasize,0,(struct sockaddr *)&cliAddr,&cliLen);   

  if (n<0)
    perror("recvfrom");
  else
  { jbyteArray jba = (*env)->NewByteArray(env,datasize);     
    (*env)->SetByteArrayRegion(env,jba,0,datasize,(jbyte*) buf);         
    return ((jbyteArray) jba);
  }
}



JNIEXPORT jint JNICALL 
Java_ActiveReceive_get_1rcv_1buf   (JNIEnv *env, jobject jobj)
{ 
  int socket_size, iret;
  socklen_t len=sizeof(socket_size); 
  iret = getsockopt (S,SOL_SOCKET,SO_RCVBUF,(char*) &socket_size, &len);

  if (iret==0)
   return (socket_size);
  else
    {perror("getsockopt");
     return(-1);
    }  
}



JNIEXPORT jint JNICALL 
Java_ActiveReceive_set_1rcv_1buf  (JNIEnv *env, jobject jobj, jint socket_size)
{ int  iret;
  socklen_t len = sizeof(socket_size);   
  iret = setsockopt (S,SOL_SOCKET,SO_RCVBUF,(char *) &socket_size,sizeof(socket_size));

  if(iret==0)  
   return (iret);
  else
    return(-1);
}








