#include <jni.h>
#include "ActiveSend.h"

#include <errno.h>
#include <stdlib.h>
#include <sys/uio.h>

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <netinet/ip.h>
#include <netinet/tcp.h>


#define IP_OPTIONS_SIZE 44
#define datasize 6500


char buf [datasize];
int type=0;


JNIEXPORT jint JNICALL 

Java_ActiveSend_init_1socket (JNIEnv *env, jobject jobj,jint S,jstring mcast_addr, jint port)
{ 
  struct hostent *h;
  struct sockaddr_in  cliAddr;
  unsigned char ttl = 128;  
  int iret;
  socklen_t len;
  char *pBuf;  
  char optionsBuffer[IP_OPTIONS_SIZE];
  struct sockaddr_in servAddr;   

  char *maddr = (char *)(*env)->GetStringUTFChars(env,mcast_addr, 0);  
  
  h = gethostbyname (maddr);
  
  /*Verifier l'exactitude de l'adresse IP*/

  if (h==NULL)
    {printf("%s: Unknow host\n",*maddr);
     exit (1);
    }

  servAddr.sin_family = h->h_addrtype;
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0],h->h_length);
  servAddr.sin_port =htons(port);

  /*Verifier que l'adresse IP est multicast*/

  if(!IN_MULTICAST(ntohl(servAddr.sin_addr.s_addr)))
     { printf("%s: is not  multicast\n", maddr);
       exit(1);
       }

  /*Creer la socket*/

  S = socket (AF_INET,SOCK_DGRAM,0);

  if (S<0)
    { printf("cannot open socket\n");
     exit(1);
    }

  cliAddr.sin_family = AF_INET;
  cliAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  cliAddr.sin_port =htons (0);

  if (bind(S,(struct sockaddr *) &cliAddr, sizeof(cliAddr))<0)
    { printf("cannot bind socket\n");
      exit(1);
    }
  
   /*mettre le ttl en place*/

  if (setsockopt(S,IPPROTO_IP,IP_MULTICAST_TTL,&ttl,sizeof(ttl))<0)
    { printf("cannot set ttl\n");
      exit(1);
      }
    

  memset (optionsBuffer, IPOPT_END,IP_OPTIONS_SIZE);
  len = IP_OPTIONS_SIZE;

  iret = getsockopt (S,IPPROTO_IP,IP_OPTIONS,(void *)optionsBuffer, &len);

  pBuf = optionsBuffer;
  while (*pBuf != IPOPT_END) pBuf++;

  *pBuf = IPOPT_RA;
  pBuf++;

  *pBuf = 4 ;
  pBuf++;

  *pBuf = 0;
  pBuf++;

  *pBuf = 0;
  pBuf++;
  
  len = len+4;

  while (len&3)
    len++;

  if(len>IP_OPTIONS_SIZE)
    len = IP_OPTIONS_SIZE;

  iret = setsockopt (S,IPPROTO_IP,IP_OPTIONS,(void *)optionsBuffer, len);

  if (iret!=0)
    { printf("cannot set bit Router Alert\n");
      exit(1);
      }     

  return(S);
}


JNIEXPORT void JNICALL 

Java_ActiveSend_write  (JNIEnv *env, jobject jobj, jint S,jbyteArray jba,jint len,jstring mcast_addr,jint port)
{ 
  
  struct sockaddr_in servAddr;
  struct hostent *h;
  char *maddr = (char *)(*env)->GetStringUTFChars(env,mcast_addr, 0);  
  h = gethostbyname (maddr);
  servAddr.sin_family = h->h_addrtype;
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0],h->h_length);
  servAddr.sin_port =htons(port);

  int i=0;  
  char buf [datasize];

 // jsize mlen = (*env)->GetArrayLength(env,jba);
  jbyte *body = (*env)->GetByteArrayElements(env,jba,0);

  for (i=0;i<len;i++)
    buf[i]=body[i];  
 
  if ((len==0)||(sendto(S,buf,len, 0, (struct sockaddr *)&servAddr, sizeof(servAddr)) == -1))
  err("write");

  /*On essaye de ralentire l'misssion*/
  int j=0;
  for (j=0;j<4000000;j++)
       {0^0;
        1^1;
	2^2;
       }
}

JNIEXPORT void JNICALL 

Java_ActiveSend_close_1socket (JNIEnv *env, jobject jobj, jint S)

{ close (S);
 
  return;
}


JNIEXPORT jint JNICALL 

Java_ActiveSend_get_1snd_1buf  (JNIEnv *env, jobject jobj, jint S)


{ int socket_size, iret;  
  int len = sizeof(socket_size); 
  iret = getsockopt (S,SOL_SOCKET,SO_SNDBUF,&socket_size, &len);

  if (iret==0)
   return (socket_size);
  else    
    {perror("getsockopt");     
     return(-1);
    }  
}


JNIEXPORT jint JNICALL 

Java_ActiveSend_set_1snd_1buf  (JNIEnv *env, jobject jobj, jint S, jint socket_size)

{ int  iret;
  int s_size=(int)socket_size; 
  socklen_t  len = sizeof(s_size); 
  iret = setsockopt (S,SOL_SOCKET,SO_SNDBUF,&s_size, len);

  if(iret==0)  
   return (iret);
  else
    {perror("setsockopt");     
     return(-1);
    }  
}
