#include <jni.h>
#include "ActiveSend.h"

#include <errno.h>
#include <stdlib.h>
#include <sys/uio.h>

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <netinet/ip.h>
#include <netinet/tcp.h>


#define IP_OPTIONS_SIZE 44

int S;
char optionsBuffer[IP_OPTIONS_SIZE];
struct sockaddr_in servAddr;
char buf [6500];


JNIEXPORT void JNICALL 

Java_ActiveSendUnicast_init_1socket (JNIEnv *env, jobject jobj)
{ 
  struct sockaddr_in  cliAddr;
  int iret;
  socklen_t len;
  char *pBuf;

  S = socket (AF_INET,SOCK_DGRAM,0);
  if (S<0)
    { printf("cannot open socket\n");
     exit(1);
    }

  cliAddr.sin_family = AF_INET;
  cliAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  cliAddr.sin_port =htons (0);

  if (bind(S,(struct sockaddr *) &cliAddr, sizeof(cliAddr))<0)
    { printf("cannot bind socket\n");
      exit(1);
    }

  memset (optionsBuffer, IPOPT_END,IP_OPTIONS_SIZE);
  len = IP_OPTIONS_SIZE;

  iret = getsockopt (S,IPPROTO_IP,IP_OPTIONS,(void *)optionsBuffer, &len);

  pBuf = optionsBuffer;
  while (*pBuf != IPOPT_END) pBuf++;

  *pBuf = IPOPT_RA;
  pBuf++;

  *pBuf = 4 ;
  pBuf++;

  *pBuf = 0;
  pBuf++;

  *pBuf = 0;
  pBuf++;
  
  len = len+4;

  while (len&3)
    len++;

  if(len>IP_OPTIONS_SIZE)
    len = IP_OPTIONS_SIZE;

  iret = setsockopt (S,IPPROTO_IP,IP_OPTIONS,(void *)optionsBuffer, len);

  if (iret!=0)
    { printf("cannot set bit Router Alert\n");
      exit(1);
      }

  /*iret = connect (S,(struct sockaddr *)&servAddr,sizeof(servAddr));

  if (iret!=0)
    { printf("cannot connect socket\n");
      exit(1);
      }*/
  
  //printf ("Socket Unicast initialisee\n");
  
  return ;

}


JNIEXPORT void JNICALL 
Java_ActiveSendUnicast_write (JNIEnv *env, jobject jobj, jstring address, jint port, jbyteArray jba, jint len)
{ struct hostent *h;
  char *addr;
  int i;

  jbyte *body = (*env)->GetByteArrayElements(env,jba,0);
  jsize mlen = (*env)->GetArrayLength(env,jba);

  for (i=0;i<mlen;i++)
    buf[i]=body[i];
  
  addr = (*env)->GetStringUTFChars(env,address, 0);
  h = gethostbyname (addr);
  
  if (h==NULL)
    {printf("%s: Unknow host\n",*addr);
     exit (1);
    }
  
  servAddr.sin_family = h->h_addrtype;
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0],h->h_length);
  servAddr.sin_port =htons(port);

  if (sendto(S,buf,mlen, 0, (struct sockaddr *)&servAddr, sizeof(servAddr)) == -1)
    err("write");

  

}





