/**
 * Demultiplex_raw.java
 *
 * @author Jean-Patrick Gelas
 */

import java.io.*;
import java.net.*;
import java.util.StringTokenizer;
import java.util.Date;

class Demultiplex_raw extends Thread
{
    final static boolean DBG = true;

    TANet net;


    // TCP [_constructor_]
    Demultiplex_raw( Socket s )
    {
	if(DBG) System.out.println("Demultiplex_raw (tcp) : _constructor_");
	net = new TANet( TANet.TCP, s, false);
    }

    public void run()
    {
	boolean add_in_list = false;
	String req;

	try {
	    while((req = net.raw_rd.readLine()) != null ) {
		if(DBG) System.out.println("# " + req);
		if(req.trim().equals("")) break;
 
		if(req.indexOf("HTTP/") != -1) {
		    net.serviceName = "http://"+
			TAMANOIRd.SERVICE_BROKER_ADDRESS+"/"+"ActiveWebS";
		    net.mesg = req;
		    break;
		}
	    } // while

	    if(net.serviceName != null) {
		if(!TAMANOIRd.serviceManager.contains(net.serviceName)) {
		    TAMANOIRd.serviceManager.download(net.serviceName);
		    add_in_list = true;
		}
		String sn = new String(net.serviceName);
		if(sn.startsWith("http:")) {
		    StringTokenizer stok = new StringTokenizer(sn,"/");
		    stok.nextToken(); // http:	
		    stok.nextToken(); // 140.77.15.124
		    sn = stok.nextToken();
		}
		Class cl = Class.forName ( sn );
		Service ns = (Service) ( cl.newInstance () );
		if(DBG) System.out.println("Demultiplex_raw : Class.forName("+
					   sn+"), " + "cl.newInstance()");
		if(add_in_list) 
		    TAMANOIRd.serviceManager.add(net.serviceName, ns);
		add_in_list = false;
		ns.init( net );
		ns.start();	    
	    }
	} catch (IOException e) {
	    System.err.println( "Demultiplex_raw (tcp) : " + e );
	    e.printStackTrace();
	    return;
	} catch (ClassNotFoundException e) { 
	    System.err.println( "Demultiplex_raw : " + e ); 
	} catch (InstantiationException e) { 
	    System.err.println( "Demultiplex_raw : " + e ); 
	} catch (IllegalAccessException e) { 
	    System.err.println( "Demultiplex_raw : " + e ); 
	}
	//if(net.proto == TANet.TCP) break; 
	if(DBG) System.out.println("Demultiplex_raw : Thread done");
    } // run()



} // class Demultiplex_raw




