
import java.io.*;
import java.net.InetAddress;

/*
 * Copyright 1997 by Carl A. Gunter, Mike Hicks, Pankaj Kakkar,
 * Jonathan Moore, Scott Nettles, and Sam Weber
 *
 * $Id: Marshalling.java,v 1.1.1.1 2002/05/21 11:39:51 jp Exp $
 * $Revision: 1.1.1.1 $
 */

class Marshalling {
    static void putInt (OutputStream os, int i) throws IOException {
	int sign;

	if (i<0) {
	    sign = 1;
	    i = -i;
	} else
	    sign = 0;

	int int0 = i%256; i /= 256; /*System.out.println ("i is now " + i);*/
	int int1 = i%256; i /= 256; /*System.out.println ("i is now " + i);*/
	int int2 = i%256; i /= 256; /*System.out.println ("i is now " + i);*/
	int int3 = i%256; i /= 256; /*System.out.println ("i is now " + i);*/

	// XXXXX Have to change this to send/receive just 4 bytes, not 5.

	/*System.out.println ("Writing : " + sign + ":" + int0 + ":" + int1 + ":" + int2 + ":" + int3);*/
	os.write (sign); os.write (int0); os.write (int1); os.write (int2); os.write (int3);
    }

    static int getInt (InputStream is) throws IOException {
	int sign = is.read ();
	int int0 = is.read (); /*if (int0 > 127) int0 -= 256;*/
	int int1 = is.read (); /*if (int1 > 127) int1 -= 256;*/
	int int2 = is.read (); /*if (int2 > 127) int2 -= 256;*/
	int int3 = is.read (); /*if (int3 > 127) int3 -= 256;*/

	/*System.out.println ("Read : " + sign + ":" + int0 + ":" + int1 + ":" + int2 + ":" + int3);*/
	
	int i = 0;
	i *= 256; i += int3; /*System.out.println ("i is now " + i);*/
	i *= 256; i += int2; /*System.out.println ("i is now " + i);*/
	i *= 256; i += int1; /*System.out.println ("i is now " + i);*/
	i *= 256; i += int0; /*System.out.println ("i is now " + i);*/

	return (sign==0)?i:-i;
    }

    static void putString (OutputStream os, String s) throws IOException {
	int i;

	putInt (os, s.length ());
	for (i=0; i<s.length (); i++)
	    putChar (os, s.charAt (i));
    }

    static String getString (InputStream is) throws IOException {
	int length = getInt (is);
	int i; String retValue = "";

	for (i=0; i<length; i++)
	    retValue += getChar (is);

	return retValue;
    }

    static void putChar (OutputStream os, char c) throws IOException {
	os.write ((byte)c);
    }

    static char getChar (InputStream is) throws IOException {
	return (char)(is.read ());
    }

    static void putBoolean (OutputStream os, boolean b) throws IOException {
	if (b)
	    os.write (1);
	else
	    os.write (0);
    }

    static boolean getBoolean (InputStream is) throws IOException {
	int i = is.read ();

	if (i==0)
	    return false;
	else
	    return true;
    }

    static void putByte (OutputStream os, byte b) throws IOException {
	os.write (b);
    }

    static byte getByte (InputStream is) throws IOException {
	return (byte)(is.read ());
    }

    static void putTLV (OutputStream os, TLV tlv) throws IOException {
	byte [] value = tlv.getValue ();
	int i, length = tlv.getLength ();

	putByte (os, (byte)((tlv.getType ())/256));
	putByte (os, (byte)((tlv.getType ())%256));

	putByte (os, (byte)((tlv.getLength ())/256));
	putByte (os, (byte)((tlv.getLength ())%256));

/* 
   BUG---BUG---BUG---BUG 
 	for (i=0; i<length*4; i++)
 	    putByte (os, value [i]);
   BUG---BUG---BUG---BUG 
*/
	for (i=0; i<length; i++)
	    putByte (os, value [i]);

    }

    static TLV getTLV (InputStream is) throws IOException {
	byte [] value;
	int i;

	int type = (int)Marshalling.getByte (is);
	type = type * 256 + (int)Marshalling.getByte (is);

	int length = Marshalling.getByte (is);
	length = length * 256 + (int)Marshalling.getByte (is);


/* 
   BUG---BUG---BUG---BUG 
	value = new byte [length*4];
	for (i=0; i<length*4; i++)
	    value [i] = getByte (is);
   BUG---BUG---BUG---BUG 
*/
	value = new byte [length];
	for (i=0; i<length; i++)
	    value [i] = getByte (is);

	return new TLV (type, length, value);
    }
}

/*
 * $Log: Marshalling.java,v $
 * Revision 1.1.1.1  2002/05/21 11:39:51  jp
 * Tamanoir project
 *
 * Revision 1.3  1997/10/19 18:08:00  mwh
 * allowed only class access
 *
 * Revision 1.2  1997/10/17 17:36:21  pankaj
 * *** empty log message ***
 *
 */
