/**
 * Toolbox.c
 *
 * @author Jean-Patrick Gelas
 */

/*
  export LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH

  javac Toolbox.java
  javah -jni Toolbox
  gcc -c -I/opt/netsoft/jdk/include -fPIC Toolbox.c
  gcc -shared -W1 -o libToolbox.so Toolbox.o
  javac Testnat.java
*/


#include <stdio.h>
#include <jni.h>
#include <unistd.h>  

#include <sys/time.h>

#include "Toolbox.h"


struct timeval tv1,tv2;
struct timezone tz;

JNIEXPORT void JNICALL Java_Toolbox_startChrono_1micros(JNIEnv * env, jobject o)
{
  gettimeofday(&tv1, &tz);
}

JNIEXPORT void JNICALL Java_Toolbox_stopChrono_1micros(JNIEnv * env, jobject o)
{
  gettimeofday(&tv2, &tz);
}

JNIEXPORT jlong JNICALL Java_Toolbox_getChrono_1micros(JNIEnv * env, jobject o)
{
  return((tv2.tv_sec-tv1.tv_sec) * 1000000L + (tv2.tv_usec-tv1.tv_usec));
}
