package ibp;
//
// CapStatus.java
//
// Written by Yong Zheng.  May 2001
//

/** 
   * This class holds the status of the capability.
   *
   *  @author	Yong Zheng
   */
import java.util.*;


public class CapStatus {
	// constructor
	
	/**
			
		*/
	CapStatus() {};
	
	CapStatus( long readRef, long writeRef, long curSize, long size,CapAttribute attr){
		readRefCount = readRef;
		writeRefCount = writeRef;
		currentSize = curSize;
		maxSize = size;
		capAttr = attr;
	};
	 	
	// class field
	private long		readRefCount;
	private long		writeRefCount;
	private long		currentSize;
	private long		maxSize;
	private CapAttribute	capAttr;
	

	// methods
	public void setReadRefCount( long readRef) { readRefCount = readRef; };
	public void setWriteRefCount( long writeRef) { writeRefCount = writeRef; };
	public void setCurSize ( long curSize ){ currentSize = curSize ; };
	public void setMaxSize ( long size ) { maxSize = size; };
	public void setCapAttr ( CapAttribute attr ) { capAttr = attr; };
	
	public long getReadRefCount ( ) { return readRefCount ; };
	public long getWriteRefCount ( ) { return writeRefCount; };
	public long getCurrentSize( ){ return currentSize; };
	public long getMaxSize() { return maxSize ;};
	public CapAttribute getCapAttr() { return capAttr; };
	
	public String toString(){
		return("ReadRefCount = " + getReadRefCount() + "\n" + 
		       "WriteRefCount = " + getWriteRefCount() + "\n" +
		       "CurrentSize = " + getCurrentSize() + "\n" +
		       "MaxSize = " + getMaxSize() + "\n" + 
		       getCapAttr()); 
	};
	
	public static void main( String[] args){
		CapStatus capSt = new CapStatus();
		
		try {
			capSt.setReadRefCount(1);
			capSt.setWriteRefCount(2);
			capSt.setCurSize(100);
			capSt.setMaxSize(100001);
			capSt.setCapAttr(new CapAttribute(new Date().getTime()+100,IBPProtocol.IBP_STABLE,IBPProtocol.IBP_BUFFER));

			CapAttribute attr = new CapAttribute( new Date().getTime()+100,IBPProtocol.IBP_STABLE,IBPProtocol.IBP_BUFFER);
		
			CapStatus capSt1 = new CapStatus( 1,2, 100,1212,attr);
		
			System.out.println("capSt1:\n" + capSt);
			System.out.println("capSt2=\n" + capSt1);
		}catch ( IBPException e){
			System.err.println("Error in IBP!");
			System.exit(-1);
		};		
		
	};
};    
     
