/**
 * Ibp_testS.java
 *
 * @author Jean-Patrick Gelas
 */


import ibp.*;

import java.io.*;
import java.net.*;
import java.util.Vector;
import java.util.Enumeration;

class Ibp_testS extends Service 
{
    final static boolean DBG = true;

    static final String IBP_DEPOT_NAME = "resamc"; // use a predefined depot
    static final int    IBP_DEPOT_PORT = 6716;
    static final int    CAP_SIZE = 1000 ; // KBytes 

    static final int TAMANOIR_Port = 5432;
    
    IBPDepot     dpt ;
    CapAttribute attr ;
    IBPCaps      caps ;
    
    WriteCap wc ;
    ReadCap  rc ;

//    long offset = 0;
//    byte [] buffer; 
    

    Ibp_testS() 
    {
	try{
            dpt = new IBPDepot( IBP_DEPOT_NAME ,IBP_DEPOT_PORT );
            attr = new CapAttribute(0,IBPProtocol.IBP_STABLE, 
				    IBPProtocol.IBP_BYTEARRAY);
            caps = new IBPCaps(dpt,CAP_SIZE*1024,attr,0,0); 
            wc = caps.getWriteCap(); 
            rc = caps.getReadCap();  
        } catch (UnknownHostException e) {
        } catch (IBPException e) {
	    System.err.println( "###->"+e);
        } catch (IOException e) {
        }
	if(DBG) System.out.println( "Ibp_testS : build" );
    }

    public void run()
    { 
	long ret1 = 0;

	while(!FINISHED) {

	    try {
		// 1/ cache payload in the local ibp depot 
		ret1 = wc.write( getANEPkt().payload, 
				 getANEPkt().payload.length );
		System.err.println("Ibp_testS: write in " + IBP_DEPOT_NAME +
				   " depot : " + ret1 + " bytes");
		
		// 2/ send cached data immediately
		forward();
		//net.sendANEPkt_next()

	    }catch (IOException e) {
		System.err.println("Ibp_testS 1: " + e);
	    }catch (IBPException e) {
		System.err.println("Ibp_testS 2: " + e);
	    }

	    // 3/ wait for the next ANEP packet
	    recv();
	} // while(!FINISHED)

	//net.close();
	//last_destId = null;
	
	if(DBG) System.out.println("Ibp_testS : run() thread done.");
    } // run()

    public void process()
    {
	//if(DBG) net.display();
    }
} // class Ibp_testS



/* -----------------------------------------------------------------------*/

