/**
 *  MonitorS.java
 *
 *  @author Jean-Patrick Gelas
 */


import java.io.*;
import java.net.*;

class MonitorS extends Service 
{
    final static boolean DBG = true;

    int delay = 1000; // default delay (ms)
    
    final static int LONG_SIZE = 8; // (Bytes) 64 bits signed integer

    MonitorS() 
    {
	if(DBG) System.out.println( "MonitorS : build" );
    }

    public void run()
    {
	if(DBG) System.out.println("MonitorS : Thread Start");
	try {
	    // read delay (int) in payload
	    ByteArrayInputStream bais = 
		    new ByteArrayInputStream( net.getANEPkt().payload );
	    DataInputStream dis = new DataInputStream( bais );
	    delay = dis.readInt();
	    if(DBG) System.out.println("MonitorS: delay = " + delay);
	    dis.close();
	    bais.close();

	    while(!FINISHED) {

		// read statistics variables in TAMANOIRd 

		// build payload

		ByteArrayOutputStream baos = 
		    new ByteArrayOutputStream(8*LONG_SIZE);
		DataOutputStream dos = new DataOutputStream( baos );
		
		dos.writeLong(TAMANOIRd.recv_udp_counter);
		dos.writeLong(TAMANOIRd.inputsize_udp_counter);
		dos.writeLong(TAMANOIRd.send_udp_counter);
		dos.writeLong(TAMANOIRd.outputsize_udp_counter);
		

		dos.writeLong(TAMANOIRd.recv_tcp_counter);
		dos.writeLong(TAMANOIRd.inputsize_tcp_counter);
		dos.writeLong(TAMANOIRd.send_tcp_counter);
		dos.writeLong(TAMANOIRd.outputsize_tcp_counter);

		// build ANEP packet
		net.makeANEPkt( net.serviceNameinBytes, 
				net.destId.getBytes(),
				net.srcId.getBytes(),
				net.destId.getBytes(),
				net.proxyTANId.getBytes(),
				baos.toByteArray());
		net.sendANEPkt(); // send info to TAMonitor tools
		sleep(delay);
	    }
	    //} catch (BadANEPversionException e) {
	    //System.err.println( "MonitorS : recvANEPkt() : Received "+
	    //"unsupported ANEP version "+
	    //"exception : " + e );
	} catch (InterruptedException e) {
	    System.err.println("MonitorS : timeout [>"+
			       net.timeout+"]");
	} catch (IOException e) {
	    System.err.println( "MonitorS : run() : " + e );
	}
	//dos.close();
	//baos.close();
	net.close();
	if(DBG) System.out.println("MonitorS : Thread done");
    }

    public void process()
    {
    }
} // class MonitorS




