/**
 *  PingS.java
 *
 *  @author Jean-Patrick Gelas
 */


import java.io.*;
import java.net.*;

class PingS extends Service 
{
    final static boolean DBG = true;

    PingS() 
    {
	if(DBG) System.out.println( "PingS : build" );
    }

    public void run()
    {
	if(DBG) System.out.println("PingS : Thread Start");
	try {
	    while(!FINISHED) {
		if(net.localhost.equals(InetAddress.getByName(net.destId))) {
		    // -- PING --
		    if(DBG) System.out.println("PingS : ---- ping !!! ----");
		    net.makeANEPkt( net.serviceNameinBytes, 
				    net.destId.getBytes(),
				    net.srcId.getBytes(),
				    net.destId.getBytes(),
				    net.proxyTANId.getBytes(),
				    net.getANEPkt().payload );
		    net.sendANEPkt();
		} else {

		    // -- FORWARD --
		    try {
			//send ANEP pkt to the next node
			net.sendANEPkt_next(); 
			if(DBG) System.out.println("PingS : forward ---->");
			if(net.proto == TANet.TCP) {
			   net.recvANEPkt_next(); // recv_next();
			   if(DBG) System.out.println("PingS : <---- forward");
			   net.sendANEPkt();
			}
		    } catch (BadANEPversionException e) {
			System.err.println( "PingS : recvANEPkt() : Received "+
					    "unsupported ANEP version "+
					    "exception : " + e );
		    } catch (InterruptedException e) {
			System.err.println("PingS : timeout [>"+
					   net.timeout+"]");
		    }
		}
		recv(); // wait for the next ANEP packet
	    }
	} catch (IOException e) {
	    System.err.println( "PingS : run() : " + e );
	}
	// net.close();
	if(DBG) System.out.println("PingS : Thread done");
    }

    public void process()
    {
    }
} // class PingS




