/**
 * XcastS.java
 *
 * @author Jean-Patrick Gelas
 */


import java.io.*;
import java.net.*;
import java.util.Vector;
import java.util.Enumeration;

class XcastS extends Service 
{
    final static boolean DBG = true;

    Vector destId_list; // in Bytes

    String last_destId = ""; 

    XcastS() 
    {
	destId_list = new Vector(); // in Bytes
	if(DBG) System.out.println( "XcastS : build" );
    }

    public void run()
    {
	while(!FINISHED) {
	    // test if a new client is coming
	    if(!last_destId.equals(net.destId)) {
		try {
		    if(last_destId.equals("")) { // first client
			destId_list.addElement(net.wr_nxt);
			if(DBG) System.out.println("XcastS : 1st client ! ["+
						   last_destId+"]");
			last_destId = net.destId;
		    } else {
			last_destId = net.destId;
			InetAddress ia_newCli = 
			    InetAddress.getByName(last_destId);
			Socket s = new Socket( ia_newCli, 5432 );
			DataOutputStream dos = 
			    new DataOutputStream(s.getOutputStream());
			destId_list.addElement(dos);
			if(DBG) System.out.println("XcastS : New client ! ["+
						   last_destId+"]");
		    }
		}catch(UnknownHostException e) {
		    System.err.println("XcastS : " + e);
		}catch(IOException e) {
		    System.err.println("XcastS : " + e);
		}
	    }
	    // send data to every clients in Vector destId_list

	    Enumeration e = destId_list.elements();
	    try {
		while(e.hasMoreElements()) {
		    DataOutputStream wr = 
			(DataOutputStream)e.nextElement();
		    wr.writeInt(getANEPkt().payload.length);
		    wr.write(getANEPkt().payload, 0,
			     getANEPkt().payload.length);
		    //wr.flush();
		    //System.out.println("XcastS : " + wr);
		} // while(e.hasMoreElem...
	    }catch(IOException eio) {
		System.err.println("XcastS : " + eio);
	    }
	    recv();    // wait for the next ANEP packet
	}
	net.close();
	last_destId = null;
	destId_list = null;
	
	
	if(DBG) System.out.println("XcastS : run() thread done.");
    }

    public void process()
    {
	//getANEPkt().payload[getANEPkt().payload.length-1] = 0;
	if(DBG) net.display();
    }
} // class XcastS




