/**
 * RecvPackets.java
 *
 * @author Jean-Patrick Gelas
 */


/*

WARNING use this class with with transmiter embedding time stamp in
the beginning of the payload. (long System.currentTimeMillis)

*/

import java.io.*;
import java.net.*;

public class Receiver extends Thread
{
    static final String VERSION = "0.1";

    static final boolean DBG = false;
    
    static int modulo = 100; // display info every MODULO sent packets
    static boolean quiet = false ;

    static final int MAX_SIZE = 800000;    //1024 * 64;
    static byte[] payload = new byte[MAX_SIZE];

    static int proto = TANet.TCP; // default protocol is TCP

    static String serverName   = null;
    static int    serverPort   = 5432; // default port
    static String proxyTANname = null;
    static int    proxyTANport = 5432; // default port


    // UDP variables
    static DatagramSocket ds;

    static ServerSocket ss;


    //Saad
    static int num=0;
    static int maxNumberOfStreams = 20; // processed by a server 
  
    //Constructor
    Receiver()
    {
	//	this.num = number;
	//	try {
	this.start();
	//	    this.ss.close();
	//	    System.err.println("server socket closed...");
	//	}catch (IOException e) {
	//	    System.err.println( "Send : " + e );
	//	}
	
	//	if(DBG) displayOptions();
	//	TANet.init_session(proxyTANname, proxyTANport, serverName, serverPort);
    }



    public static void displayOptions()
    {
	System.err.println ("Server       : " + serverName );
	System.err.println ("Server port  : " + serverPort );
	System.err.println ("proxy TAN    : " + proxyTANname );
	System.err.println ("port  TAN    : " + proxyTANport );
	System.err.println ("quiet mode   : " + quiet );	
        System.err.print   ("protocole    : " );
	switch(proto) {
	case TANet.UDP : System.err.println("UDP"); break;
	case TANet.TCP : System.err.println("TCP"); break;
	default : System.err.println( "unknown" );
	}
    }


    // recvStream() : receive payload stream and write it on stdout
    public static int recvStream( DataInputStream rd ) 
    {
	int cpt = 0;
	int c,size;// used by case TCP
	int count = 0, total_count = 0; 
	BufferedOutputStream stdout = null;
	if(!quiet) stdout = new BufferedOutputStream( System.out );

	// for time stamp read in payload
	long start_time = 0, total_time = 0;
	ByteArrayInputStream bais = new ByteArrayInputStream(payload);
	DataInputStream dis = new DataInputStream( bais );	


	try {
	    for(;;) {
		switch(proto) {
		case TANet.TCP:
		    size = rd.readInt(); // read size of data incoming

		    if(DBG) System.err.println( "RecvPacket size="+size);
		    count = 0;
		    while (count < size ) {
			c = rd.read( payload, count, size - count );
			if(c<0) break; // client socket has been closed
			count += c;
			if(DBG) System.err.println( "recvStream (tcp):transfer in progress = ["+count+"] + " + c );
		    }
		    if(DBG) System.err.println( "recvStream (tcp): reception"+
						" completed [" + count +
						" Bytes]" );
		    break;

		case TANet.UDP:
		    DatagramPacket dp = new DatagramPacket (payload, MAX_SIZE);
		    ds.receive (dp);
		    count = dp.getLength();
		    if(DBG) System.err.println( "recvStream (udp): reception"+
                                                " completed [" + count +
                                                " Bytes]" );

		    break;
		} //switch()
		total_count += count ;

		// and write its payload on stdout
		if(!quiet) {
		    stdout.write( payload, 0, count );
		    stdout.flush();
		}

		
		// get time stamp at the beginning of the payload
		if(start_time == 0) {
		    start_time = dis.readLong();
		} else {
		    if( cpt++ % modulo == 0 ) {
			dis.reset();
			long t = dis.readLong() - start_time;
			if(t>0){ 
				System.err.println("[#"+num+"]"+((8.0*total_count)/(t*1000)) + 
						" Mbit/s");
				System.err.println((((total_count / 4096)*1000)/t) + 
						" pps (si 4096 Bytes)");
			}
		    }
		}

		if(DBG) if( cpt % modulo == 0 )
		    System.err.println( "Receiver : #" + cpt );

	    } // for(;;)
	} catch (IOException e) {
	    System.err.println("Receiver : " + e);
	}	
	return 1;
    }

    public void run()
    {

	try {
	    switch(proto) {
	    case TANet.TCP:
		ss = new ServerSocket( proxyTANport );
		System.err.println("[# "+num+"] Receiver : waiting for data on port " 
				   + proxyTANport);
		//		if(s != null) {
		try {
		    //		    while (true) {
		    for (int i = 0; i < maxNumberOfStreams; i++) {
			TANet.init_session(proxyTANname, proxyTANport, serverName, serverPort);
			Socket s = ss.accept();
			ThreadCl t = new ThreadCl(s);
			t.start();
		    }
		    
		}catch (IOException e) {
		    e.printStackTrace();
		} finally {
		    try {
			ss.close();
		    } catch (IOException e) {}
		}
		break;
		
	    case TANet.UDP:
		ds = new DatagramSocket ( proxyTANport );
		if(ds != null) {
		    recvStream( null );
		} else
		    System.err.println("Receiver (udp): problem !");
		break;
	    } // switch()
	    System.err.println("[# "+num+"] Receiver : Thread termine.");
        } catch (IOException e) {
            System.err.println( "[# "+num+"]Receiver! :: " + e );
	}
	
    } // run()



    public static void receivp(String proxyTan, String serverNam, String prot ) 
    {
	try {
	    if (ss != null) ss.close();
	}catch (IOException e) {
	    System.err.println( "Send : " + e );
	}

	proxyTANname = proxyTan;
	serverName = serverNam;

	if(prot=="TCP")
	    proto = TANet.TCP;
	else
	    if (prot=="UDP")
		proto = TANet.UDP;
	
	if(serverName == null || proxyTan == null) {
	    System.err.println("bad arguments...");
	    System.exit (1);
	}
	new Receiver();
    } // receivP



    class ThreadCl extends Thread {
	
	Socket clientSocket;   
	//    ServerSocket sSock;
	
	ThreadCl(Socket clientSock) throws IOException {
	    
	    System.err.println("Start thread");
	    this.clientSocket = clientSock;
	    
	}
	public void run() {  
	    
	    try {
		//	    clientSocket = sSock.accept();
		DataInputStream rd=new DataInputStream(clientSocket.getInputStream());
		Receiver.recvStream( rd );
		clientSocket.close();
		
	    } catch(IOException e) {
		e.printStackTrace();
	    } finally {
		try {
		    clientSocket.close();
		    System.err.println("Un thread termine");
		} catch(Exception e) {
		}
	    }
	}
    }
}








