/**
 * SendPackets.java : multithreaded stream server.
 *
 * @author Jean-Patrick Gelas
 */

import java.net.*;
import java.io.*;
import java.util.*;

public class Sender extends Thread
{
    static final String VERSION = "0.1";

    static final boolean DBG = true;
    
    static String serviceName = "FwdS"; // default service
    static int modulo = 100; // display info every 'modulo' sent packets
    static int delay  = 500; // default delay (ms) between each sent packet
    static String  proxyTAN = null;
    static int     proxyTANport = 5432; // default port
    static int     serverPort = 5432;   // default port
    //    static boolean fix = false;
    static int fix_size;
    // clients info
    String hostNameClient; // its name
    String proxyTANclient; // its proxyTAN
    int proxyTANportClient;// ...

    static int proto = TANet.TCP; // default protocol is TCP

    static String srcFileName = null ; // path for source file

    static int payloadSize = 4*1024; // default payload size
    static byte [] payload ;
    static final int SIZEOF_LONG = 8;

    static int numberOfStreams = 1;

    // TCP variables -----------------------------
    static ServerSocket ss;
    Socket cc;            // current connection
    TANet net;
    
    //Saad
    int num = 0;
    static int num_of_stream = 1;
    static int num_cc = 0;
    static String result = "null";
    static int ManagerPort = 7654;

    // TCP constructor
    Sender(){
    }
    Sender( Socket s, int num )
    {
        cc = s;
	//Saad
	this.num = num;
    } 




    public static void displayOptions()
    {
	System.out.println ("Service Name : " + serviceName );
	System.out.println ("Delay        : " + delay );
	System.out.println ("proxy TAN    : " + proxyTAN );
	System.out.println ("port  TAN    : " + proxyTANport );
	System.out.print   ("source       : " );
	if(srcFileName == null) System.out.println("stdin");
	else System.out.println( srcFileName );
        System.out.print   ("Protocole    : " );
	switch(proto) {
	case TANet.UDP : System.out.println("UDP"); break;
	case TANet.TCP : System.out.println("TCP"); break;
	default : System.out.println( "unknown" );
	}
	System.out.println ("Payload size : " + payloadSize);
    }


    //  sendFix
    //
    //  send always the same ANEP packet
    //
    //  5/11/2001: 64 first bits (long) of the payload are used as time-stamp
    //
    public int sendFix()
    {
	// cache some data
	byte [] srvNameinBytes    = serviceName.getBytes();
	byte [] destIdinBytes     = hostNameClient.getBytes(); 
	byte [] proxyTANIdinBytes = proxyTANclient.getBytes(); 

	byte [] srcIdinBytes      = net.srcId.getBytes();
        byte [] lastIdinBytes     = srcIdinBytes;

	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	DataOutputStream dos = new DataOutputStream( baos );

	try {
	    long t1,t2; // chrono variables
	    int cpt=0;
	    
	    for(int i=0; i<payloadSize;i++) payload[i] = 73;

	    int total_sz = fix_size; 
	    int sz = total_sz;
	    t1 = System.currentTimeMillis();
            while(sz > payloadSize) {

		if( cpt % modulo == 0 ) {
		    baos.reset();
		    dos.writeLong(System.currentTimeMillis());
		    System.arraycopy(baos.toByteArray(), 0, 
				     payload, 0, SIZEOF_LONG);
		}
		
		net.makeANEPkt( srvNameinBytes, srcIdinBytes, 
				destIdinBytes, lastIdinBytes, 
				proxyTANIdinBytes,
				payload );
		net.sendANEPkt();

		if( cpt++ % modulo == 0 )
		    System.out.println( "[# "+num+"]Sender : #" + cpt );
		sz -= payloadSize;
		if(delay != 0) try { 
		    Thread.sleep( delay ); } 
		catch (InterruptedException e) {
		}
	    } // while()

	    if(sz != 0) {
		byte [] t = new byte[sz];
		System.arraycopy(payload,0,t,0,sz);
		baos.reset();
		dos.writeLong(System.currentTimeMillis());
		System.arraycopy(baos.toByteArray(), 0, t, 0, SIZEOF_LONG);

		net.makeANEPkt( srvNameinBytes, srcIdinBytes, 
				destIdinBytes, lastIdinBytes, 
				proxyTANIdinBytes, t );
		net.sendANEPkt();
	    }
		
	    t2 = System.currentTimeMillis();
	    long t = t2 - t1;

	    result = "R( Sender::"+InetAddress.getLocalHost ().getHostAddress()+" -> Receiver::"+hostNameClient+"),"
		+" [stream # "+num+"]=> "
		+((8*total_sz)/(1000*t))+" Mbits/sec.";
	    sendResult(result);
	    
	    System.err.println( "[# "+num+"]Sender : " + t + "ms for " +
				total_sz + "Bytes." );
	    System.err.println( "[# "+num+"]=> " + ((8*total_sz)/(1000*t))  
				+ " Mbits/sec." );
	    System.err.println( "[# "+num+"]=> " +  (((total_sz / payloadSize) * 1000) / t) 
				+ " packets/sec." );


	} catch (FileNotFoundException e ) { 
	    System.out.println("Sender : " + e ); 
	} catch (EOFException e ) { 
	    System.err.println("Sender : EOF '"+ srcFileName +"'"); 
	} catch (IOException e ) { 
	    System.err.println("Sender : " + e );
	    System.exit(0);
	}
	return 0;
} // sendFix()

    public void sendResult(String res){
	try {
		
	    InetAddress ma_server = InetAddress.getByName( "140.77.13.59" );
	    //		System.err.println("ma-server::"+ma_server.toString());
	    Socket s = new Socket( ma_server, ManagerPort );
	    s.setTcpNoDelay(true); // 12062002
	    
	    DataOutputStream wr = new DataOutputStream(s.getOutputStream());
	    wr.writeUTF( result ); // I have a ...connexionType.
	    System.err.println("results transmitted...");
	    wr.close();
	}catch (UnknownHostException e) {
	    System.err.println( "Client : " + e );
	}catch (IOException e) {
	    System.err.println( "Client : " + e );
	}
	
    }//sendResult
    
    public void run()
    {
	try {
	    // recover some informations from client (its name,
	    // proxyTANname where it is connected, and port)
	    DataInputStream rd_cli = new DataInputStream(cc.getInputStream());

	    hostNameClient = rd_cli.readUTF();
	    proxyTANclient = rd_cli.readUTF();
	    proxyTANport   = rd_cli.readInt();

	    if(DBG) System.out.println("[# "+num+"]Sender : (new cnx) client:"+
				       hostNameClient+" proxyTAN:"+
				       proxyTANclient+" ("+
				       proxyTANport+")"
				       );
	    rd_cli.close();
	    cc.close(); // we don't use anymore this connection.
	} catch (IOException e) {
	    System.err.println( "Sender (tcp): " + e );
	}
	
	
	// Now we have to connect this thread to the closest proxyTAN
	// (given by arguments -tan hostname)
	switch(proto) {
        case TANet.TCP:
	    net = new TANet( TANet.TCP, proxyTAN, proxyTANport );
	    break;
	
	case TANet.UDP:
	    net = new TANet( TANet.UDP, proxyTAN, proxyTANport );
	    break;
	}
	
	// and finally send data...
	//	if(fix) 
	sendFix();
	net.close();
	if(net.dsr != null) net.dsr.close();
	if(DBG) System.out.println("[# "+num+"]Sender : run() thread done.");
    } // run()
    
    //Saad

    public static String sendp(String proxyTan, String prot, int fix, int delaye, int ps, String serviceNam, int numberofstreams) {
	try {
	    if (ss!=null) ss.close();
	}catch (IOException e) {
	    System.err.println( "Send : " + e );
	}


	if(prot=="TCP")
	    proto = TANet.TCP;
	else
	    if (prot=="UDP")
		proto = TANet.UDP;

	proxyTAN = proxyTan;
	fix_size = fix;
	delay = delaye;
	payloadSize = ps;
	serviceName = serviceNam;
	num_of_stream = numberofstreams;

	payload = new byte[payloadSize];
	try {
	    ss = new ServerSocket( serverPort );
	    //	    while( true ) {
	    //Saad
	    for(;num_cc < num_of_stream; num_cc++) { 
		System.out.println("Sender (tcp): waiting for connection"+
				   " on port " + serverPort);
		Socket s1 = ss.accept();
		
		Sender sp = new Sender( s1, num_cc);
		sp.start(); // start thread
		System.err.println("Sender started..."); 
		
	    }
	    //	    System.err.println("servsocket closed...");
	    //	    ss.close();
	    //	    }
	} catch (IOException e) {
	    System.err.println( "Sender : " + e );
	}
	return result;
		    
    }	
    
}

