/**
 *  GzipS.java
 *
 *  Compresses/Decompresses a byte array buffer 
 *
 *  @author Jean-Patrick Gelas
 */


import java.io.*;
import java.net.*;
import java.util.zip.*;


class GzipS extends Service 
{
    final static boolean DBG = true;
    int sods = 0;
    int sodr = 0;
    byte[] bufout;
    byte[] bufoutend = new byte[10000];
    byte[] bufoutzip = new byte[64000];
    int zip = 0;
    int j = 0;
    int gun;

    GzipS() 
    {
	if(DBG) System.out.println( "GzipS : build" );
    }

    public void run()
    {
	name =        "Compression Gzip";
	institution = "ENS Lyon";
	author =      "seh";
	date =        "2003";
	comment =    "";
	serverbroker ="localhost"; 

	try {
	    while(!FINISHED) {
		
		// compresses data in the GZIP format
		System.out.println(net.getANEPkt().payload.length);
		if (j==0){
		    System.out.println("aneppaquet : "+net.getANEPkt().payload[net.getANEPkt().payload.length-1]);
		    if (net.getANEPkt().payload[net.getANEPkt().payload.length-1] != 1){
			//on compresse le premir paquet
			System.out.println("GzipS: Compression...");
			zip = 1;
			bufout = GZIPdata( net.getANEPkt().payload );
			//		    byte[] bzip = (byte)zip;
			//for (int i=0;i<=bzip.length;i++)
			int i;
			for (i=0;i<bufout.length;i++){
			    bufoutend[i] = bufout[i]; 
			}
			int size = i;
			bufoutend[size+1] = (byte)1;
			byte [] buff = new byte[size+2];
			for (int k=0;k<=size+1;k++){
			    buff[k] = bufoutend[k]; 
			}
			
			System.out.println("buff : "+buff[buff.length-1]);
			
			double gain = 100.0 - (( 100.0 * bufout.length ) / (getANEPkt().payload.length ));
			if(DBG) System.out.println( "GzipS : gain = " + gain );
			net.makeANEPkt( net.serviceNameinBytes, 
					net.srcId.getBytes(),
					net.destId.getBytes(),
					net.lastId.getBytes(), 
					net.proxyTANId.getBytes(),
					buff
					);
			net.sendANEPkt_next();
			
			recv();    // wait for the next ANEP packet
			sods = sods+buff.length;
			sodr = sodr+net.getANEPkt().payload.length;
		    }
		    else {
			//on dcompresse le premir paquet
			System.out.println("GzipS : Dcompression...");
			gun = GUNZIPdata (net.getANEPkt().payload, bufoutzip);
			bufout = new byte[gun];
			for (int l=0;l<gun;l++)
			    bufout[l] = bufoutzip[l];

			double gain = 100.0 - (( 100.0 * bufout.length ) / (getANEPkt().payload.length ));
			if(DBG) System.out.println( "GunzipS : gain = " + gain );
			net.makeANEPkt( net.serviceNameinBytes, 
					net.srcId.getBytes(),
					net.destId.getBytes(),
					net.lastId.getBytes(), 
					net.proxyTANId.getBytes(),
					bufout
					);
			net.sendANEPkt_next();
			
			recv();    // wait for the next ANEP packet
			sods = sods+bufout.length;
			sodr = sodr+net.getANEPkt().payload.length;
		    }
		}
		else { //traitement du reste des paquets
		    if (zip ==1){//on compresse
			System.out.println("GzipS: Compression....");
			bufout = GZIPdata( net.getANEPkt().payload );
			double gain = 100.0 - (( 100.0 * bufout.length ) / (getANEPkt().payload.length ));
			if(DBG) System.out.println( "GzipS : gain = " + gain );
			net.makeANEPkt( net.serviceNameinBytes, 
					net.srcId.getBytes(),
					net.destId.getBytes(),
					net.lastId.getBytes(), 
					net.proxyTANId.getBytes(),
					bufout
					);
			net.sendANEPkt_next();
			
			recv();    // wait for the next ANEP packet
			
			System.out.println("bufin size : "+net.getANEPkt().payload.length);
			System.out.println("bufout size : "+bufout.length);

			sods = sods + bufout.length;
			sodr = sodr+net.getANEPkt().payload.length;
	    }
		    else {//on dcompresse
			System.out.println("GzipS : Dcompression....");
			gun = GUNZIPdata (net.getANEPkt().payload, bufoutzip);
			bufout = new byte[gun];
			for (int l=0;l<gun;l++)
			    bufout[l] = bufoutzip[l];

			double gain = 100.0 - (( 100.0 * bufout.length ) / (getANEPkt().payload.length ));
			if(DBG) System.out.println( "GunzipS : gain = " + gain );
			net.makeANEPkt( net.serviceNameinBytes, 
					net.srcId.getBytes(),
					net.destId.getBytes(),
					net.lastId.getBytes(), 
					net.proxyTANId.getBytes(),
					bufout
					);
			net.sendANEPkt_next();
			
			recv();    // wait for the next ANEP packet
			System.out.println("bufin size : "+net.getANEPkt().payload.length);
			System.out.println("bufout size : "+gun+"  "+bufout.length);
			sods = sods+bufout.length;
			sodr = sodr+net.getANEPkt().payload.length;
		    }
		}
		j++;
	    }
	} catch (IOException e) {
            System.err.println( "GzipS : run() " + e );
        }
	net.close();
	if(DBG) System.out.println("GzipS : run() thread done.");
    } // run()

    public void process()
    {
    }


    // GZIPdata : return a byte array of compressed data in the GZIP
    // format.
    public static byte [] GZIPdata( byte [] bufin )
	throws IOException
    {
	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	GZIPOutputStream gzos = new GZIPOutputStream(baos);

	gzos.write(bufin,0,bufin.length);
	gzos.close();
	return (baos.toByteArray());
    }

    // GUNZIPdata : returns quantity of decompressed bytes available
    // in bufout.  (we don't know the size of decompressed data before
    // decompressing data) (bufout must be oversized)
    public static int GUNZIPdata( byte [] bufin, byte [] bufout )
	throws IOException
    {
	ByteArrayInputStream bais = new ByteArrayInputStream( bufin );
	GZIPInputStream gunzipis = new GZIPInputStream( bais );
	
	System.out.println("bufin size before gunzip :"+ bufin.length);
	int v = gunzipis.read( bufout, 0, bufout.length );
	System.out.println("bufout size after gunzip :"+ bufout.length);
	gunzipis.close();
	return v;
    }
    public String getInfo()
    {
	return("<html><head><meta http-equiv=\"refresh\" content=\"3\"><title>GzipS Informations</title>"+
	       "<TABLE BORDER=4 CELLSPACING=2 CELLPADDING=2>"+
	       "<tr><td>Data size received</td><td>"+sodr+"</td></tr>"+
	       "<tr><td>Data size sent</td><td>"+sods+"</td></tr>");
    }



} // class GzipS



/*
public class C2 {

    static final int SIZE = 4096;
    static byte[] bufin = new byte[SIZE];
    static byte[] bufout;
    static byte[] bufin2;
    static byte[] bufout2 = new byte[2 * SIZE];

    public static void main(String[] args) {
      
	// init bufin
	for(int i=0; i<bufin.length;++i)
	    bufin[i] = (byte)i;  

	System.out.println( "START: bufin.length  = " + bufin.length);


	try {
	    // compresses data in the GZIP format
	    bufout = GZIPdata( bufin );
	    System.out.println( "[GZIP] bufout.length = " + bufout.length);

	    // decompresses data that has been stored in the GZIP format
	    bufin2 = bufout;
	    int v = GUNZIPdata( bufin2, bufout2 );
	    System.out.println( "[GUNZIP] decompr. bytes (v) = " + v);

	    // diff buffers -----------------------------
	    for(int i=0; i < v; i++)
		if(bufin[i] != bufout2[i]) 
		    System.out.print("ERROR");

	}
	//Simply print out any errors we encounter.
	catch (Exception e) {
	    System.err.println(e);
	}
    } // main()
    



    // return a byte array of compressed data in the GZIP format
    public static byte [] GZIPdata( byte [] bufin )
	throws IOException
    {
	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	GZIPOutputStream gzos = new GZIPOutputStream(baos);

	gzos.write(bufin,0,bufin.length);
	gzos.close();
	return (baos.toByteArray());
    }




    // returns quantity of decompressed bytes available in bufout.
    // (we don't know the size of decompressed data before decompressing data)
    // (bufout must be oversized)
    public static int GUNZIPdata( byte [] bufin, byte [] bufout )
	throws IOException
    {
	ByteArrayInputStream bais = new ByteArrayInputStream( bufin );
	GZIPInputStream gunzipis = new GZIPInputStream( bais );

	int v = gunzipis.read( bufout, 0, bufout.length );
	gunzipis.close();
	return v;
    }

}
*/


