/**
 *  Monitor service
 *
 *  @author Sad El Hadri
 */

import java.util.Hashtable;
import java.util.Enumeration;
import java.io.*;
import java.net.*;

class MapCenterS extends Service 
{
    final static boolean DBG = true;
    static int serverPort = 7654;

    MapCenterS() 
    {

	if(DBG) System.out.println("MapCenterS : build...");
    }

    public void run()
    {
	if(DBG) System.out.println("MapCenter : Thread Start");
	name =        "MapCenter Monitor";
	institution = "ENS Lyon";
	author =      "seh";
	date =        "2003";
	comment =    "";
	serverbroker ="localhost"; 

	try {
	    ServerSocket ss = new ServerSocket( serverPort );

	    for(int i=0;;) {
 		System.out.println("MapCenter : waiting for connection"+
 				   " on port " + serverPort);
 		Socket s = ss.accept();

		CatchQuery cq = new CatchQuery( s );
 		cq.start();
	    }

	} catch (IOException e) {
	    System.err.println("MapCenter: " + e );
	}



	if(DBG) System.out.println("MapCenter : Thread done");
    }

    public void process()
    {
    }
    public String getInfo()
    {
	return ("<h1>No Info to display for "+this.name+" service</h1>");
    }

} // class MapCenterS

class CatchQuery extends Thread {

    Socket clientSocket;


    public CatchQuery(Socket clientSocket) throws IOException {
	this.clientSocket = clientSocket;
    }

    public void run() {  
	try {
	    DataOutputStream wrw = new DataOutputStream(clientSocket.getOutputStream());
	    DataInputStream rd=new DataInputStream(clientSocket.getInputStream());
	    String query = rd.readLine();
	    System.out.println("query::"+query);

	    if (query.equals("list")){ //list of services dispo in this TAN
		System.out.println("trait query...");
		String header = "<p align="+"center"+"><b><span lang="+"fr"+"><font size="+"7"+
		    ">Services List</font></span></b></p><p align="+"center"+"><img src="+"/var/www/ServerBroker/Services/aedgrule.gif"+"></p>";
		byte[] buff = header.getBytes();
		//		wrw.write(buff,0,header.length());
		
		int num = 1;
		for( Enumeration e = TAMANOIRd.serviceManager.services.keys() ; e.hasMoreElements(); num++ ) {
		    String key = (String)e.nextElement();
		    System.out.println("key::"+key);
		    ServiceDefinition el = (ServiceDefinition)TAMANOIRd.serviceManager.services.get( key );	
		    //Service elem = el.getService();
		    long old_s = el.getAge_ms() / 1000 ;
		    System.out.println( num + ") " + key + " : "+ el.getHint() + 
				" times used, " + old_s + " old seconds" );

		    Service elem = TAMANOIRd.serviceManager.get(key);
		    String sb = elem.serverbroker;
		    System.out.println("elem::"+TAMANOIRd.serviceManager.get(key).name);
		    System.out.println("<html><head><title>"+key+" Service Informations</title>"+
				       "<Body ><A href= http://"+sb+"/ServerBroker/servicesInfo/"+key+
				       ".html"+">"+elem.name+"</A></body></html>");
		    String someInfo = "<A href= http://"+sb+"/ServerBroker/servicesInfo/"+key+".html"+">"+num+"."+elem.name+"</A>"+
			"servname="+key;
		    buff = someInfo.getBytes();
		    wrw.write(buff,0,someInfo.length());
		    wrw.flush();
		    System.err.println("results transmitted...");
 		}
		wrw.close();
	    }

	    if (query.equals("info")){ //some info about this TAN
		System.out.println("number of received packets::"+TAMANOIRd.recv_tcp_counter);
		System.out.println("number of send packets::"+TAMANOIRd.send_tcp_counter);
		System.out.println("data size received::"+TAMANOIRd.inputsize_tcp_counter);
		System.out.println("data size transmitted::"+TAMANOIRd.outputsize_tcp_counter);
		String someInfo = "<html><head><meta http-equiv=\"refresh\" content=\"3\"><title>TAN Informations</title>"+
		    "<body ><h1>TAN Informations</h1>"+
		    "<TABLE BORDER=4 CELLSPACING=2 CELLPADDING=2>"+
		    "<tr><td>Number of received packets</td><td>"+TAMANOIRd.recv_tcp_counter+"</td></tr>"+
		    "<tr><td>Number of send packets</td><td>"+TAMANOIRd.send_tcp_counter+"</td></tr>"+
		    "<tr><td>Data size received</td><td>"+TAMANOIRd.inputsize_tcp_counter+"</td></tr>"+
		    "<tr><td>Data size transmitted</td><td>"+TAMANOIRd.outputsize_tcp_counter+"</td></tr>"+
		    "</table></body></html>";
		byte[] buff = someInfo.getBytes();
		wrw.write(buff,0,someInfo.length());
		wrw.flush();
		System.err.println("results transmitted...");
		wrw.close();

	    }
	    
	    if (query.startsWith("infoserv")){ //info about service
		String servicename = query.substring(8);
		System.out.println("servicename::"+servicename);
		Service serv = TAMANOIRd.serviceManager.get(servicename);
		String someInfo = serv.getInfo();
		System.out.println("someInfo::"+someInfo);
		byte[] buff = someInfo.getBytes();
		wrw.write(buff,0,someInfo.length());
		wrw.flush();
		System.err.println("results transmitted...");
		wrw.close();
	    }

	} catch(IOException e) {
	    e.printStackTrace();
	}
    }
}
